


#include <NexConfig.h>
#include <NexNumber.h>
#include <NexPage.h>
#include <NexText.h>
#include <Adafruit_BME280.h>
#include <Adafruit_Sensor.h>
#include <Adafruit_GPS.h>
#include <SoftwareSerial.h>

#define GPSECHO  false  //Muestra (true) o No muestra(false) las sentencias NMEA
SoftwareSerial mySerial(11, 10); // RX, TX
SoftwareSerial nextionSerial(16, 17); //Ubicacion de los pines RX, TX de la pantallas RX->16 TX ->17
Adafruit_BME280 bme; // I2C
Adafruit_GPS GPS(&mySerial);


//Definicion de objetos

NexNumber n7 = NexNumber(1, 7, "n7"); // Lat_G
NexNumber n8 = NexNumber(1, 9, "n8"); // Lat_M
NexNumber n9 = NexNumber(1, 10, "n9"); //N-S
NexText t50 = NexText(1, 14, "t50");

NexNumber n10 = NexNumber(1, 8, "n10"); // Lon_G
NexNumber n11 = NexNumber(1, 11, "n11"); //Lon_M
NexNumber n12 = NexNumber(1, 12, "n12"); //E-W
NexText t51 = NexText(1, 15, "t51");

 

void setup() {

  Serial.begin(9600);
  bme.begin();
  nexInit();
  GPS.begin(9600);
  GPS.sendCommand(PMTK_SET_NMEA_OUTPUT_RMCGGA);
  GPS.sendCommand(PMTK_SET_NMEA_UPDATE_1HZ);
  GPS.sendCommand(PGCMD_ANTENNA);
  GPS.sendCommand(PMTK_ENABLE_WAAS);

}

uint32_t timer = millis();
byte ndt[3] = {255, 255, 255};

void loop() {

  datosGPS();

 }

void datosGPS() {

  // if a sentence is received, we can check the checksum, parse it...
  if (GPS.newNMEAreceived()) {
    if (!GPS.parse(GPS.lastNMEA()))   // this also sets the newNMEAreceived() flag to false
      return;  // we can fail to parse a sentence in which case we should just wait for another
  }
  // si millis () o el timer se ajustan, solo lo reiniciaremos
  if (timer > millis())  timer = millis();
  // aproximadamente cada 2 segundos más o menos, imprime las estadísticas actuales
  if (millis() - timer > 2000) {
    timer = millis(); // resetea el temporizador (timer)
  }

  float Latitud;
  int Lat_G;
  int Lat_M;
  int Lat_S;
  float Longitud;
  int Lon_G;
  int Lon_M;
  int Lon_S;
  char c = GPS.read();


  if (GPS.fix) {

    // Transformacion de Latitud decimal a gg.mm.ss

    if (GPS.latitudeDegrees < 0) {
      Latitud = GPS.latitudeDegrees * -1;
      Lat_G = GPS.latitudeDegrees / - 1;             //Calcula la parte entera de los Grados
      Lat_M = ((Latitud - Lat_G) * 60) / 1;         //Calcula la parte entera de los Minutos
      Lat_S = ((((Latitud - Lat_G) * 60) - Lat_M) * 60) / 1; //Calcula la parte entera de los Segundos
    }
    else {
      Latitud = GPS.latitudeDegrees;
      Lat_G = GPS.latitudeDegrees / 1;              //Calcula la parte entera de los Grados
      Lat_M = ((Latitud - Lat_G) * 60) / 1;         //Calcula la parte entera de los Minutos
      Lat_S = ((((Latitud - Lat_G) * 60) - Lat_M) * 60) / 1; //Calcula la parte entera de los Segundos
    }

    // Transformacion de Longitud decimal a gg.mm.ss
    if (GPS.longitudeDegrees < 0) {

      Longitud = GPS.longitudeDegrees * -1;         //Calcula la Longitud en valor absoluto
      Lon_G = (GPS.longitudeDegrees / -1);
      Lon_M = ((Longitud - Lon_G) * 60) / 1;
      Lon_S = ((((Longitud - Lon_G) * 60) - Lon_M) * 60) / 1;
    }
    else {
      Longitud = GPS.longitudeDegrees * 1;         //Calcula la Longitud en valor absoluto
      Lon_G = (GPS.longitudeDegrees / 1);
      Lon_M = (((Longitud - Lon_G) * 60) / 1);
      Lon_S = ((((Longitud - Lon_G) * 60) - Lon_M) * 60) / 1;
    }
 
    n7.setValue(Lat_G);              //Imprime Grados de Latitud
    n8.setValue(Lat_M);              //Imprime Minutos de Latitud
    n9.setValue(GPS.lat);            //Imprime lectura en ASCII de la latitud N-S
    t50.setText(int (GPS.lat));           //Dería sacar por pantalla N o S   
    Serial.write(ndt, 3);
    n10.setValue(Lon_G);        //Imprime Grados de Longitud
    n11.setValue(Lon_M);        //Imprime Minutos de Longitud
    n12.setValue(GPS.lon);      //Imprime Longitud E-W
    t51.setText(char(int (GPS.lon)));

//Imprime datos de Latitud y Longitud en Puerto serie para comprobacion

    Serial.write(ndt, 3);
    Serial.print(Lat_G);Serial.print("º ");Serial.print(Lat_M);Serial.print("m "); //Imprime datos Latitud en Puerto serie
    Serial.print(Lat_S);Serial.print("s ");Serial.println(GPS.lat);
    
    Serial.print(Lon_G);Serial.print("º ");Serial.print(Lon_M);Serial.print("m "); //Imprime datos Longitud en Puerto serie
    Serial.print(Lon_S);Serial.print("s ");Serial.println(GPS.lon);
    delay(1000);
    Serial.write(ndt, 3);   
  }
}
